/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EDITKEY_H
#define EDITKEY_H

#include <QLineEdit>
#include <QKeySequence>
#include <QKeyEvent>
#include "contextmanager.h"

class EditKey : public QLineEdit
{
    Q_OBJECT

public:
    EditKey(int octave, ConfManager::Key key, QWidget * parent = nullptr);
    void updateText();

    QSize sizeHint() const override;

protected:
    void focusInEvent(QFocusEvent * event) override;
    void keyPressEvent(QKeyEvent * event) override;
    void keyReleaseEvent(QKeyEvent * event) override;
    void focusOutEvent(QFocusEvent * event) override;

private:
    void processKeyEvent(QKeyEvent * event);

    int _octave;
    ConfManager::Key _key;
};

#endif // EDITKEY_H
