/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2019 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef TREEITEMFIRSTLEVEL_H
#define TREEITEMFIRSTLEVEL_H

#include "treeitem.h"
#include "basetypes.h"
#include "indexedelementlist.h"
class TreeItemRoot;

class TreeItemFirstLevel: public TreeItem
{
public:
    TreeItemFirstLevel(QString label, IndexedElementList<TreeItem *> * children, TreeItemRoot *parent, EltID id);
    virtual ~TreeItemFirstLevel() override;

    int childCount() const override;
    TreeItem * child(int row) override;
    QString display() override;
    int row() override;
    int indexOfId(int id) override;

private:
    QString _label;
    int _row;
    IndexedElementList<TreeItem *> * _children;
};

#endif // TREEITEMFIRSTLEVEL_H
